// Parameterliste.cpp: Implementierung der Klasse Parameterliste.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Parameterliste.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

Parameterliste::Parameterliste()
{
	maxparameter = 0;
	lastparameter = -1;
	for (int i=0; i<100; i++) used[i]=0;
}

Parameterliste::~Parameterliste()
{
	//lsche alle Parameter wieder
}

void Parameterliste::loadParam(char x[MAXZEILE])
{
	char paramname[MAXPARAMNAME];

	int i=0;
	int lx=strlen(x);
	if (lx>0) {

		int istkommentar=0;
		int teilDesNamens = 1;
		while ((i<lx)&&(teilDesNamens == 1))
		{
			if ((x[i] == '=') || (x[i]== ';') || ((x[i]=='-')&&(i+1<lx)&&(x[i+1]=='-'))) //; beendet die Eingabe -- ist Kommentar
			{
				teilDesNamens = 0;
				if ((x[i]=='-')&&(i+1<lx)&&(x[i+1]=='-')) 
					istkommentar=1;
			}
			else
			{
				paramname[i]=x[i];
				i++;
			}
		}
		if (istkommentar==-1)
		{
			paramname[i]='\0';
		}
		else
			paramname[i++]='\0';

		//hinten die Blanks lschen
		int l = strlen(paramname)-1;
		while ((l>=0)&&(paramname[l]==' '))
			paramname[l--]='\0';

		//gibt es diesen Parameter schon?
		int index = findParameter(paramname);

		if (index==-1) 
		{
			index = maxparameter++;
		}

		strcpy (parametername[index], paramname);


		//extrahiere Parameterwert
		parameterwert[index][0] = '\0';
		teilDesNamens = 1;
		istkommentar=0;
		int starti = i;
		while ((i<lx)&&(teilDesNamens == 1))
		{
			if ((x[i]== ';') || ((x[i]=='-')&&(i+1<lx)&&(x[i+1]=='-')))//; beendet die Eingabe -- ist Kommentar
			{
				teilDesNamens = 0;
				if ((x[i]=='-')&&(i+1<lx)&&(x[i+1]=='-')) 
					istkommentar=1;
			}
			else
			{
				if ((x[i]==' ')&&(starti==i))
					starti++;
				else
					parameterwert[index][i-starti]=x[i];

				i++;
			}
		}
		if (istkommentar==-1)
			parameterwert[index][i - starti]='\0';
		else
			parameterwert[index][i++ - starti]='\0';

		//hinten die Blanks lschen
		l = strlen(parameterwert[index])-1;
		while ((l>=0)&&(parameterwert[index][l]==' '))
			parameterwert[index][l--]='\0';

		// der Rest ist Kommentar
		kommentar[index][0] = '\0';
		while ((i<lx)&&(x[i]==' ')) i++;
		if ((x[i]=='-')&&(i+1<lx)&&(x[i+1]=='-')) 
		{
			starti = (i=i+2);
			while (i<lx)
			{
				if ((x[i]==' ')&&(starti==i))
					starti++;
				else
					kommentar[index][i-starti]=x[i];

				i++;
			}
			kommentar[index][i++ - starti]='\0';

			//hinten die Blanks lschen
			l = strlen(kommentar[index])-1;
			while ((l>=0)&&(kommentar[index][l]==' '))
				kommentar[index][l--]='\0';
		}

		lastparameter = index;
	} // if lx>0, also berhaupt etwas zu tun ist
}

int Parameterliste::findParameter(char paramname[MAXPARAMNAME])
{
	if (strcmp(paramname, "\0") == 0)
		return -1; // ein leerer String ist immer neu
	else
	{
		int i = 0;
		for (i=0; i<=maxparameter-1; i++)
			if (strcmp(paramname, parametername[i]) == 0)
				return i;

		return -1; // nicht gefunden
	}
}

char* Parameterliste::readParameter(char paramname[MAXPARAMNAME])
{
	int i = findParameter(paramname);
	if (i==-1)
		return "";
	else
		return parameterwert[i];
}

char* Parameterliste::getLastParameter()
{
	int i = lastparameter;
	if (i==-1)
		return "";
	else
		return parametername[i];
}

char* Parameterliste::strOutputParameterIntern(int i, char *wert /* buffer */)
{
	//char wert[MAXZEILE];
	wert[0]='\0';

	if (i>-1){
		int j = sprintf(wert, "%s = %s; -- %s" , parametername[i], parameterwert[i], kommentar[i]);
		used[i] = 1;
	}

	return wert;
}

char* Parameterliste::strOutputParameter(char paramname[MAXPARAMNAME], char *wert /* buffer */)
{
	int i = findParameter(paramname);
	//char wert[MAXZEILE];
	
	wert[0]='\0';

	if (i>-1){
		int j = sprintf(wert, "%s = %s; " , parametername[i], parameterwert[i]);
		used[i] = 1;
	}

	return wert;
}

char* Parameterliste::strOutputParameterNotYet(char *wert /* buffer */)
{
	for (int i=0; i<maxparameter; i++)
	{
		if ((used[i]==0)&&(parametername[i][0] != '\0'))
		{
			return strOutputParameterIntern(i, wert);
		}
	}
	return NULL;
}

void Parameterliste::SetParameter(char* paramname, char* paramwert)
{
	int index;
	index = findParameter(paramname);
	if (index==-1)
	{
		index = maxparameter ++;
		strcpy (parametername[index], paramname);
	}

	strcpy (parameterwert[index], paramwert);
}
