// Frommer.cpp: Implementierung der Klasse Frommer.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "frommer.h"
#include "polynom.h"
#include <iostream.h>
#include <stdlib.h>

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

Frommer::Frommer(int m, koerper *kk)
{
	setMaxStrudel(m);

	setKoerper(kk);

	p=0;
	q=0;
	A=0;
	B=0;
	dxA=0;
	dyA=0;
	a=0;

	strudelGroessen = (zahl*) malloc(sizeof(zahl)*(maxStrudel+1) );
}

Frommer::~Frommer()
{
	free(strudelGroessen);
}

void Frommer::init()
{
	//das sind alles leere Polynome
	if (p != 0) delete(p);
	//if (q != 0) delete(q);
	if (A != 0) delete(A);
	if (B != 0) delete(B);
	if (dxA != 0) delete(dxA);
	if (dyA != 0) delete(dyA);
	if (a != 0) delete(a);

	//p = new polynomxy(maxGrad);
	//q = new polynomxy(maxGrad);
	A = new polynomxy(maxGrad);
	B = new polynomxy (maxGrad);
	dxA = new polynomxy (maxGrad);
	dyA = new polynomxy (maxGrad);
	a = new polynomx (maxGrad/2 +1);
	
	//Initialisieruzng von A
	//aktueller_grad=2;
	A->SetKoeff (2,0,1);
	A->SetKoeff (1,1,0);
	A->SetKoeff (0,2,1);
}

void Frommer::setPolynome(polynomxy *pp, polynomxy *qq) 
{
	init();
	int i;
	for (i=0; i<maxStrudel; i++) 
	{
		strudelGroessen[i].x = 0;
		strudelGroessen[i].eps = 0;
	}
	//p=pp;
	q=qq;
	p = new polynomxy(maxGrad);
	//p mu nun noch negiert werden
	int  j;
	zahl z;
	for (i=0; i<= pp->getGrad(); i++)
		for(j=0; j<=i; j++)
		{
			z = pp->GetKoeff(i-j, j); 
			p->SetKoeff (i-j, j , k->negativ(z));
		}

};

//entspricht der Maple-Funktion ableitung 
// bildet dyA, dxA
void Frommer::bildeAbleitung()
{
	int i;
	for (i=0; i<=aktueller_grad; i++)
	{
		dyA->SetKoeff(i, aktueller_grad-2-i, k->multipliziere (aktueller_grad-1-i, A->GetKoeff(i, aktueller_grad-1-i) ));
		dxA->SetKoeff(i, aktueller_grad-2-i, k->multipliziere(i+1, A->GetKoeff(i+1, aktueller_grad-2-i)));
	}
}

//entspricht der Maple-Funktion CSchritt
//berechnet B
void Frommer::macheCSchritt()
{
	int j, l, m, n; //k aus MAple heit hier j, da k der Krper ist
	for (j=0; j<=aktueller_grad; j++)
		for (l=0; l<=aktueller_grad; l++)
			for (m=0; m<=aktueller_grad-2; m++)
				for (n=0; n<=aktueller_grad-2; n++)
					if (j+m+l+n == aktueller_grad)
						if (m+n > 0)
							B->SetKoeff(j+m, l+n, k->addiere(k->addiere(k->multipliziere(p->GetKoeff(j, l), dyA->GetKoeff(m, n))
							, k->multipliziere(q->GetKoeff(j, l), dxA->GetKoeff(m, n)))
							, B->GetKoeff(j+m, l+n)));
}

//emtspricht den Maple-Funktionen ASchrittungerade, ASchrittGerade, aberechnen
//berechnet A
void Frommer::macheASchritt()
{
	int i, j, l;
	zahl Summe, Produkt;
		
	if (aktueller_grad % 2 == 1) 
	{
		//ungerade - entspricht ASchrittungerade
		for (l=0; l<=aktueller_grad; l++)
		{
			Summe=zahl(0);
			if (l % 2 == 0)
			{
				for (i=0; i<=(aktueller_grad-l-1)/2; i++)
				{
					Produkt=zahl(1);
					for (j=i; j<=(aktueller_grad-l-3)/2; j++)
						Produkt=k->multipliziere(Produkt, k->dividiere( aktueller_grad-2*j-1 , 2*j+1 ));
					Summe = k->addiere(Summe, k->dividiere(k->multipliziere(B->GetKoeff(2*i, aktueller_grad-2*i), Produkt),aktueller_grad-l));
				}
				A->SetKoeff(aktueller_grad-l, l, k->negativ(Summe));
			}
			else //l mod 2 == 1
			{
				for(i=0; i<= (l-1)/2; i++)
				{
					Produkt=zahl(1);
					for(j=i; j<=(l-3)/2; j++)
						Produkt = k->multipliziere(Produkt, k->dividiere( aktueller_grad-2*j-1 , 2*j+1 ));
					Summe = k->addiere(Summe, k->dividiere(k->multipliziere(B->GetKoeff(aktueller_grad-2*i, 2*i), Produkt), l ));
				}
				A->SetKoeff(aktueller_grad-l, l, Summe);
			}
		}


	} else {
		//gerade

		//erst einmal klein a berechnen
		
		a->SetKoeff(0, 1);
		for (i=1; i<= aktueller_grad/4; i++)
		{
			Produkt=zahl(1);
			for (j=1; j<=i; j++)   //j wird hier statt k in Maple verwendet (weil k der koerper ist)
				Produkt = k->multipliziere(Produkt, k->dividiere(aktueller_grad - (2*j-1), 2*j-1));
			a->SetKoeff(i, Produkt);
		}
		int m;
		m = i-1; /* m ist in Maple die obere Schranke der obigen For-Schleife */
		for (i=m+1; i<=2*m+1; i++)
			a->SetKoeff(i, a->GetKoeff((aktueller_grad/2)-i));


		//jetzt kommt der gerade A-Schritt
		A->SetKoeff(0, aktueller_grad, 0);
		for (l=0; l<=aktueller_grad-1; l++)
		{
			Summe=zahl(0);
			if (l%2 == 0)
			{
				for (i=1; i<=(aktueller_grad-l)/2; i++)
				{
					Produkt=zahl(1);
					for (j=i; j<= (aktueller_grad-l-2)/2; j++)
						Produkt = k->multipliziere(Produkt, k->dividiere(aktueller_grad - 2*j, 2*j));
					Summe = k->addiere(Summe, k->multipliziere(B->GetKoeff(2*i-1, aktueller_grad-2*i+1), k->dividiere(Produkt, aktueller_grad-l)));
				}
				A->SetKoeff(aktueller_grad-l, l, k->negativ(Summe));
			}
			else // l mod 2 == 1
			{
				for (i=0; i<=(l-1)/2; i++)
					Summe = k->addiere(Summe , k->dividiere( B->GetKoeff(aktueller_grad-2*i, 2*i), a->GetKoeff(i)));
				for (j=((l-1)/2)+1; j<=aktueller_grad/2; j++)
					Summe = k->addiere (Summe , k->negativ (k->dividiere( B->GetKoeff(aktueller_grad-2*j, 2*j), a->GetKoeff(j))));
				int mini;
				if (l<aktueller_grad-l)
					mini=l;
				else
					mini = aktueller_grad - l;
				Summe = k->dividiere(Summe, mini);
				if ((l-1)/2 < (aktueller_grad-l-1)/2)
					mini = (l-1)/2;
				else
					mini = (aktueller_grad-l-1)/2;
				Summe = k->multipliziere(Summe, a->GetKoeff(mini));
				A->SetKoeff(aktueller_grad - l, l, k->dividiere(Summe, 2));
			}
		}
	}
}

void Frommer::doit(int immerbismaxstrudel)
{
	int strudel;
	strudel = 1;
	aktueller_grad = 2;
	zahl StrudelGroesse;

	int ende;
	ende =0;

//	cout << "berechne Strudelgroessen von \n";
//	cout << "p:";
//	p->ausgeben();
//	cout << endl;
//	cout << "q:";
//	q->ausgeben();
//	cout << endl;

	try
	{

		while (ende == 0)
		{
			aktueller_grad++;
			bildeAbleitung();
			macheCSchritt();
	//		cout << "B: ";
	//		B->ausgeben();
	//		cout << endl;
			macheASchritt();
	//		cout << "A: ";
	//		A->ausgeben();
	//		cout << endl;

			if (aktueller_grad % 2 == 0)
			{
				//gerade --> Strudelgre berechnen

				StrudelGroesse = k->addiere(A->GetKoeff(1, aktueller_grad-1), B->GetKoeff(0, aktueller_grad));
				if ((StrudelGroesse.x != 0)&&(immerbismaxstrudel==0))
					ende = 2;

//				cout << strudel << ". Strudelgroesse: " << (StrudelGroesse.x) << endl;

				strudelGroessen[strudel].x = StrudelGroesse.x;
				strudelGroessen[strudel].eps = StrudelGroesse.eps;

				strudel++;
				if (strudel > maxStrudel)
					ende++;
			}
		}
	}
	catch (char* str)
	{
		cout << "Beim Berechnen der " << strudel << ".Strudelgroesse ist folgender Fehler aufgetreten: " << endl << str << endl;
		strudelGroessen[strudel].x = -1;
		strudelGroessen[strudel].eps = -1;

	}
}

zahl Frommer::getStrudelGroesse(int i)
{
	zahl z;
	z.x=0; z.eps=0;
	if (i<=maxStrudel)
	{
		z.x = strudelGroessen[i].x;
		z.eps = strudelGroessen[i].eps;
	}
	return z;
}

int Frommer::azNullen()
{
	int i=0;
	while ((i<maxStrudel)&&(strudelGroessen[i+1].x==0)/*&&(strudelGroessen[i+1].eps==0)*/) i++;
	return i;
}
